
export const generateUID = () => {
  let counter = 1;

  const map = new WeakMap();

  const uid = (item, index) => {
    if (
      typeof item === 'number' ||
      typeof item === 'string'
    ) {
      return index ? `idx-${index}` : `val-${item}`;
    }

    if (!map.has(item)) {
      map.set(item, counter++);
      return uid(item)
    }
    return 'uid' + map.get(item);
  };

  return uid;
}

export default generateUID();